/***** 1. type definitions *****/
typedef unsigned long long      ULL;
typedef          int      ADDR_TYPE;
typedef          int      DATA_TYPE;


#define ENV_AREA_SIZE     0x2000  /* size of argc argv argp */
#define ENV_AREA_START     0x500  /* start of argv & argp   */
#define MEM_AREA_SIZE  10000000   /* 10M memory area as you want*/
#define MEM_TEMP_SIZE       1000  /* temp mem used by syscall */

#define bit31(N) (N >> 31)
#define OUTFILE1  outfile /* stderr */

#define FCCMASK 0xFFFFF3FF
/*call:(format 1) */
#define OP	0xc0000000
#define DISP30 	0x3fffffff

#define MASK31  0x80000000

/*branch:(format 2)*/
#define A	0x20000000
#define COND	0x1e000000
#define OP2	0x1c00000
#define DISP22	0x3fffff
#define RD	0x3e000000
#define IMM22   0x3fffff

/*others:(format 3)*/
#define OP3     0x1f80000
#define RS1	0x7c000
#define I	0x2000
#define ASI	0x1fe0
#define RS2	0x1f
#define SIMM13	0x1fff
#define BIT0_1  0x3          

#define BIT0    0x1          
#define BIT1    0x2
#define BIT2    0x4
#define BIT3    0x8
#define BIT4    0x10
#define BIT5    0x20
#define BIT6    0x40
#define BIT7    0x80
#define BIT8    0x100
#define BIT9    0x200
#define BIT10   0x400
#define BIT11   0x800
#define BIT12   0x1000
#define BIT13   0x2000
#define BIT14   0x4000
#define BIT15   0x8000
#define BIT16   0x10000
#define BIT17   0x20000
#define BIT18   0x40000
#define BIT19   0x80000
#define BIT20   0x100000
#define BIT21   0x200000
#define BIT22   0x400000
#define BIT23   0x800000
#define BIT24   0x1000000
#define BIT25   0x2000000
#define BIT26   0x4000000
#define BIT27   0x8000000
#define BIT28   0x10000000
#define BIT29   0x20000000
#define BIT30   0x40000000
#define BIT31   0x80000000

#define EXTND22  0xffc00000
#define EXTND16  0xffff0000
#define EXTND13  0xffffe000
#define EXTND8   0xffffff00
#define HALFWDH  0xffff0000
#define HALFWDL  0xffff
#define BYTEH    0xff000000
#define BYTEL    0xff
#define USGNB    0x7f
#define OPF      0x3fe0
#define OPC      0x3fe0
#define FALLMASK 0xFFFFFFFF

#define TRACE_FLAG        32768u 
#define VALUE_IR          16384u 
#define VALUE_ALL          8192u
#define OUTFILE_PRINT_ST   4096u
#define OUTFILE_PRINT_LD   2048u
#define ICOUNT_FLAG        1024u  
#define VERBOSE_FLAG        512u  
#define OUTFILE_PRINT_LD_ST 256u  
#define STDOUT_TO_FILE      128u  /* for command options */
#define OUTFILE_PRINT_FLAG   64u  
#define TICC_FLAG            32u
#define DISTRIBUTION_FLAG     8u
#define SYSTEMCALL_FLAG       4u
#define DEBUG_FLAG            2u
#define OUTFILE_FLAG          1u

/*
#include <sys/syscall.h>
#include <fcntl.h>    
#include <sys/types.h>
#include <sys/stat.h> 
#include <sys/uio.h>  
#include <sys/mman.h>
#include <sys/file.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/uio.h>
#include <memory.h>
#include <sys/termios.h>
#include <fcntl.h>

*/

#define __COPRO 200 /* temporal */
#define __FPOP  300 /* temporal */

#define __ADD  7
#define __ADDcc  8
#define __ADDX  9
#define __ADDXcc 10
#define __AND 11
#define __ANDcc 12
#define __ANDN 13
#define __ANDNcc 14
#define __Bicc 15
#define __CALL 17
#define __CBccc 18
#define __Cpop 20
#define __FABSs 21
#define __FADDd 22
#define __FADDs 23
#define __FADDx 24
#define __FBfcc 25
#define __FCMPd 27
#define __FCMPEd 28
#define __FCMPEs 29
#define __FCMPEx 30
#define __FCMPs 31
#define __FCMPx 32
#define __FDIVd 33
#define __FDIVs 34
#define __FDIVx 35
#define __FdTOi 36
#define __FdTOs 37
#define __FdTOx 38
#define __FiTOd 39
#define __FiTOs 40
#define __FiTOx 41
#define __FMOVs 42
#define __FMULd 43
#define __FMULs 44
#define __FMULx 45
#define __FNEGs 46
#define __FSQRTd 47
#define __FSQRTs 48
#define __FSQRTx 49
#define __FsTOd 50
#define __FsTOi 51
#define __FsTOx 52
#define __FSUBd 53
#define __FSUBs 54
#define __FSUBx 55
#define __FxTOd 56
#define __FxTOi 57
#define __FxTOs 58
#define __IFLUSH 59
#define __JMPL 60
#define __LD 61
#define __LDA 62
#define __LDC 63
#define __LDCRS 64
#define __LDD 65
#define __LDDA 66
#define __LDDC 67
#define __LDDF 68
#define __LDF 69
#define __LDFSR 70
#define __LDSB 71
#define __LDSBA 72
#define __LDSH 73
#define __LDSHA 74
#define __LDSTUB 75
#define __LDSTUBA 76
#define __LDUB 77
#define __LDUBA 78
#define __LDUH 79
#define __LDUHA 80
#define __MULScc 81
#define __OR 82
#define __ORcc 83
#define __ORN 84
#define __ORNcc 85
#define __RDPSR 86
#define __RDTBR 87
#define __RDWIM 88
#define __RDY 89
#define __RESTORE 90
#define __RETT 91
/* #define  92 */
#define __SAVE 93
#define __SETHI 94
#define __SLL 95
#define __SRA 96
#define __SRL 97
#define __ST 98
#define __STA 99
#define __STB 100
#define __STBA 101
#define __STC 102
#define __STCSR 103
#define __STD 104
#define __STDA 105
#define __STDC 106
#define __STDCQ 107
#define __STDF 108
#define __STDFQ 109
#define __STF 110
#define __STFSR 111
#define __STH 112
#define __STHA 113
#define __SUB 114
#define __SUBcc 115
#define __SUBX 116
#define __SUBXcc 117
#define __SWAP 118
#define __SWAPA 119
#define __TADDcc 120
#define __TADDccTV 121
#define __Ticc 122
/* #define __ 123 */
#define __TSUBcc 124
#define __TSUBccTV 125
#define __UNIMP 126
#define __WRPSR 127
#define __WRTBR 128
#define __WRWIM 129
#define __WRY 130
#define __XNOR 131
#define __XNORcc 132
#define __XOR 133
#define __XORcc 134


/** for get_class **/

#define _DONT_CR 0
#define _CONTROL 10
#define _CON_SUB 11
#define _LD      31
#define _LD_SUB  32
#define _ST      40
#define _NOP     50
#define _FLOAT   70
#define _ARITH   80
#define _TICC    90

/**********************************************************/
#define  _ADD_      7
#define  _ADDcc_    8
#define  _ADDX_     9
#define  _ADDXcc_  10
#define  _AND_     11
#define  _ANDcc_   12
#define  _ANDN_    13
#define  _ANDNcc_  14
#define  _Bicc_    15
#define  _CALL_    17
#define  _CBccc_   18
#define  _Cpop_    20
#define  _FABSs_   21
#define  _FADDd_   22
#define  _FADDs_   23
#define  _FADDx_   24
#define  _FBfcc_   25
#define  _FCMPd_   27
#define  _FCMPEd_  28
#define  _FCMPEs_  29
#define  _FCMPEx_  30
#define  _FCMPs_  31
#define  _FCMPx_  32
#define  _FDIVd_  33
#define  _FDIVs_  34
#define  _FDIVx_  35
#define  _FdTOi_  36
#define  _FdTOs_  37
#define  _FdTOx_  38
#define  _FiTOd_  39
#define  _FiTOs_  40
#define  _FiTOx_  41
#define  _FMOVs_  42
#define  _FMULd_  43
#define  _FMULs_  44
#define  _FMULx_  45
#define  _FNEGs_  46
#define  _FSQRTd_  47
#define  _FSQRTs_  48
#define  _FSQRTx_  49
#define  _FsTOd_  50
#define  _FsTOi_  51
#define  _FsTOx_  52
#define  _FSUBd_  53
#define  _FSUBs_  54
#define  _FSUBx_  55
#define  _FxTOd_  56
#define  _FxTOi_  57
#define  _FxTOs_  58
#define  _IFLUSH_  59
#define  _JMPL_    60
#define  _LD_      61
#define  _LDA_     62
#define  _LDC_     63
#define  _LDCRS_   64
#define  _LDD_     65
#define  _LDDA_    66
#define  _LDDC_    67
#define  _LDDF_    68
#define  _LDF_     69
#define  _LDFSR_   70
#define  _LDSB_    71
#define  _LDSBA_   72
#define  _LDSH_    73
#define  _LDSHA_   74
#define  _LDSTUB_  75
#define  _LDSTUBA_ 76
#define  _LDUB_    77
#define  _LDUBA_   78
#define  _LDUH_    79
#define  _LDUHA_   80
#define  _MULScc_  81
#define  _OR_      82
#define  _ORcc_    83
#define  _ORN_     84
#define  _ORNcc_   85
#define  _RDPSR_   86
#define  _RDTBR_   87
#define  _RDWIM_   88
#define  _RDY_     89
#define  _RESTORE_ 90
#define  _RETT_    91
#define  _SAVE_    93
#define  _SETHI_   94
#define  _SLL_     95
#define  _SRA_     96
#define  _SRL_     97
#define  _ST_      98
#define  _STA_     99
#define  _STB_    100
#define  _STBA_   101
#define  _STC_    102
#define  _STCSR_  103
#define  _STD_    104
#define  _STDA_   105
#define  _STDC_   106
#define  _STDCQ_  107
#define  _STDF_   108
#define  _STDFQ_  109
#define  _STF_    110
#define  _STFSR_  111
#define  _STH_    112
#define  _STHA_   113
#define  _SUB_    114
#define  _SUBcc_  115
#define  _SUBX_   116
#define  _SUBXcc_ 117
#define  _SWAP_   118
#define  _SWAPA_  119
#define  _TADDcc_ 120
#define  _TADDccTV_ 121
#define  _Ticc_    122
#define  _TSUBcc_  124
#define  _TSUBccTV_ 125
#define  _UNIMP_   126
#define  _WRPSR_   127
#define  _WRTBR_   128
#define  _WRWIM_   129
#define  _WRY_     130
#define  _XNOR_    131
#define  _XNORcc_  132
#define  _XOR_     133
#define  _XORcc_   134
